{$include SortHtmlTable.inc.pas} //HTML vystup funkci pouzitych pro razeni radku tabulky podle sloupce

function ProfileCalculateTotalTime(profileResults: TStrings):LongWord; //calculate total time
var n:Integer;
    s:string;
begin
  Result:=0;
  if(profileResults<>nil) then begin
    for n := 0 to profileResults.count-1 do begin
      s := profileResults[n];
      fetch(s,'|');
      Result := Result + StrToInt(fetch(s,'|'));
    end;
  end;
end;

function ProfileHtmlOutput(profileResults: TStrings;bRunBrowser:boolean):string;
var n:Integer;
    total:LongWord;
    s,sName,sTime:string;
    fPerc:extended;
begin
    Result:='<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"'+CRLF
         +'"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">'+CRLF
         +'<html>'+CRLF
         +'  <head>'+CRLF
         +'  <meta http-equiv="Content-type" content="text/html; Charset=utf-8" />'+CRLF
         +'  <meta name="Author" content="Gord, Medwyn" />'+CRLF
         +'  <title>Profile Statistics</title>'+CRLF
         +'  <style type="text/css">'+CRLF
         +'<!--'+CRLF
         +'    .cCopyright{margin:10px 0px 20px -px; font-style:italic; text-align:center;}'+CRLF
         +'    #iProfile tr{background-color:#f5f5f5;}'+CRLF
         +'    #iProfile{border-collapse: collapse;}'+CRLF
         +'    #iProfile thead{border: #000000 solid 3px;}'+CRLF
         +'    #iProfile th{border: #000000 solid 1px;}'+CRLF
         +'    #iProfile thead th.cName{width:300px;}'+CRLF
         +'    #iProfile thead th.cTime{width:80px;}'+CRLF
         +'    #iProfile thead th.cPerc{width:80px;}'+CRLF
         +'    #iProfile thead th.cBar{width:300px;}'+CRLF
         +'    #iProfile td{vertical-align: top; text-align:center;border: #000000 solid 1px;}'+CRLF
         +'    #iProfile .cName{text-align:left;}'+CRLF
         +'    #iProfile .cTime{text-align:center;}'+CRLF
         +'    #iProfile .cPerc{text-align:center;}'+CRLF
         +'    #iProfile .cBar{text-align:left; width:100px;}'+CRLF
         +'    #iProfile td.cBar div.cBarBar{text-align:left; background-color:#4444ff;}'+CRLF
         +'    #iProfile .dontsort td {font-weight:bold;}'+CRLF
         +'-->'+CRLF
         +'  </style>'+CRLF
         +'  </head>'+CRLF
         +'  <body>'+CRLF+SortTable(1)
         +'  <h1>Profile statistics</h1>'+CRLF
         +'  <table id="iProfile" class="sortable">'+CRLF
         +'  <thead>'+CRLF
         +'    <tr><th class="cName">Name of Function</th>'+CRLF
         +'      <th class="cTime">Processed time [ms]</th>'+CRLF
         +'      <th class="cPerc">Processed time [%]</th>'+CRLF
         +'      <th class="cBar dontsort" width="300"></th>'+CRLF
         +'  </thead>'+CRLF
         ;
  total:=ProfileCalculateTotalTime(profileResults);
  if(total>0) then begin
    for n := 0 to profileResults.count-1 do  begin
      s:=profileResults[n];
      sName:=fetch(s,'|');
      sTime:=fetch(s,'|');
      fPerc:=StrToFloat(sTime)/total*100;
      Result:=Result+'<tr><td class="cName">'+sName+'</td><td class="cTime">'+sTime+'</td>'
        +'<td class="cPerc">'+FormatFloat('0.00',fPerc)+'</td>'
        +'<td class="cBar"><div class="cBarBar" style="width:'+FormatFloat('0',fPerc*3)+'px;">&nbsp;</div></td></tr>'+CRLF
        ;
    end;
      Result:=Result+'<tr class="dontsort"><td class="cName">Suma</td><td class="cTime">'+IntToStr(total)+'</td>'
        +'<td class="cPerc">100</td>'
        +'<td class="cBar"><div class="cBarBar" style="width:300px;">&nbsp;</div></td></tr>'+CRLF
        ;
  end;
  Result:=Result+'</body></html>'+CRLF;
  if(bRunBrowser) then begin
    s:=GEOGET_DATADIR+'\Temp\';
    ForceDirectories(s);
    s:=s+'ProfileStatistics.html';
    StringToFile(Result,s);
    RunShell(s);
  end;
end;
